/*
 * $Id: progressinfodialog.cpp,v 1.1 2007/03/04 12:53:15 ozawa Exp $
 *
 * Copyright 2007- ONGS Inc. All rights reserved.
 * 
 * author: Masanori OZAWA (ozawa@ongs.co.jp)
 * version: $Revision: 1.1 $
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY ONGS INC ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ONGS INC OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the ONGS Inc.
 * 
 */

#include "../include/fusenshi.h"
#include "progressinfodialog.h"

ProgressInfoDialog::ProgressInfoDialog()
: m_cCancelButton(Gtk::Stock::CANCEL),
  m_cCloseButton(Gtk::Stock::CLOSE)
{
    set_title(_("Fusenshi - Send Information"));
    set_wmclass(APP_NAME, "ProgressInfoDialog");
    set_size_request(450, 200);
    property_destroy_with_parent() = true;

	m_cProgressBar.set_orientation(Gtk::PROGRESS_LEFT_TO_RIGHT);
	m_cProgressBar.set_ellipsize(Pango::ELLIPSIZE_END);
	get_vbox()->pack_start(m_cProgressBar, false, true, 3);
	
	m_cTextView.set_editable(false);
	m_cTextView.set_cursor_visible(true);
	m_cTextView.set_wrap_mode(Gtk::WRAP_NONE);

    Gtk::ScrolledWindow* pScrolledWnd = manage(new Gtk::ScrolledWindow());
    get_vbox()->pack_start(*pScrolledWnd, true, true, 3);
    pScrolledWnd->add(m_cTextView);

    get_action_area()->set_layout(Gtk::BUTTONBOX_END);

    add_action_widget(m_cCancelButton, Gtk::RESPONSE_CANCEL);
    m_cCancelButton.set_flags(Gtk::CAN_DEFAULT);

    add_action_widget(m_cCloseButton, Gtk::RESPONSE_CLOSE);
    m_cCloseButton.set_flags(Gtk::CAN_DEFAULT);

    set_default_response(Gtk::RESPONSE_CLOSE);

    show_all_children();
}

ProgressInfoDialog::~ProgressInfoDialog()
{
}

bool ProgressInfoDialog::on_delete_event(GdkEventAny *pEvent)
{
	return (!m_cCloseButton.is_sensitive());
}
